//***************************************
// BH1750FVI IICԳ
// ʹõƬSTC89C51 
// 11.0592M
// ʾLCD1602
// 뻷 Keil uVision2
// ο꾧վ24c04ͨų
// ʱ䣺2011420
//****************************************
#include  <REG51.H>	
#include  <math.h>    //Keil library  
#include  <stdio.h>   //Keil library	
#include  <INTRINS.H>
#define   uchar unsigned char
#define   uint unsigned int	
#define   DataPort P0	 //LCD1602ݶ˿
sbit	  SCL=P1^0;      //IICʱŶ
sbit  	  SDA=P1^1;      //IICŶ
sbit      LCM_RS=P2^0;   //LCD1602˿		
sbit      LCM_RW=P2^1;   //LCD1602˿		
sbit      LCM_EN=P2^2;   //LCD1602˿ 

#define	  SlaveAddress   0x46 //IICеĴӵַ,ALT  ADDRESSַŲͬ޸
                              //ALT  ADDRESSŽӵʱַΪ0x46ӵԴʱַΪ0xB8
typedef   unsigned char BYTE;
typedef   unsigned short WORD;

BYTE    BUF[8];                         //ݻ      	
uchar   ge,shi,bai,qian,wan;            //ʾ
int     dis_data;                       //

void delay_nms(unsigned int k);
void InitLcd();
void Init_BH1750(void);

void WriteDataLCM(uchar dataW);
void WriteCommandLCM(uchar CMD,uchar Attribc);
void DisplayOneChar(uchar X,uchar Y,uchar DData);
void conversion(uint temp_data);

void  Single_Write_BH1750(uchar REG_Address);               //д
uchar Single_Read_BH1750(uchar REG_Address);                //ȡڲĴ
void  Multiple_Read_BH1750();                               //ĶȡڲĴ
//------------------------------------
void Delay5us();
void Delay5ms();
void BH1750_Start();                    //ʼź
void BH1750_Stop();                     //ֹͣź
void BH1750_SendACK(bit ack);           //ӦACK
bit  BH1750_RecvACK();                  //ack
void BH1750_SendByte(BYTE dat);         //IICֽд
BYTE BH1750_RecvByte();                 //IICֽڶ

//-----------------------------------

//*********************************************************
void conversion(uint temp_data)  //  ת ʮ٣ǧ
{  
    wan=temp_data/10000+0x30 ;
    temp_data=temp_data%10000;   //ȡ
	qian=temp_data/1000+0x30 ;
    temp_data=temp_data%1000;    //ȡ
    bai=temp_data/100+0x30   ;
    temp_data=temp_data%100;     //ȡ
    shi=temp_data/10+0x30    ;
    temp_data=temp_data%10;      //ȡ
    ge=temp_data+0x30; 	
}

//ʱ**************************
void delay_nms(unsigned int k)	
{						
unsigned int i,j;				
for(i=0;i<k;i++)
{			
for(j=0;j<121;j++)			
{;}}						
}

/*******************************/
void WaitForEnable(void)	
{					
DataPort=0xff;		
LCM_RS=0;LCM_RW=1;_nop_();
LCM_EN=1;_nop_();_nop_();
while(DataPort&0x80);	
LCM_EN=0;				
}					
/*******************************/
void WriteCommandLCM(uchar CMD,uchar Attribc)
{					
if(Attribc)WaitForEnable();	
LCM_RS=0;LCM_RW=0;_nop_();
DataPort=CMD;_nop_();	
LCM_EN=1;_nop_();_nop_();LCM_EN=0;
}					
/*******************************/
void WriteDataLCM(uchar dataW)
{					
WaitForEnable();		
LCM_RS=1;LCM_RW=0;_nop_();
DataPort=dataW;_nop_();	
LCM_EN=1;_nop_();_nop_();LCM_EN=0;
}		
/***********************************/
void InitLcd()				
{			
WriteCommandLCM(0x38,1);	
WriteCommandLCM(0x08,1);	
WriteCommandLCM(0x01,1);	
WriteCommandLCM(0x06,1);	
WriteCommandLCM(0x0c,1);
}			
/***********************************/
void DisplayOneChar(uchar X,uchar Y,uchar DData)
{						
Y&=1;						
X&=15;						
if(Y)X|=0x40;					
X|=0x80;			
WriteCommandLCM(X,0);		
WriteDataLCM(DData);		
}						

/**************************************
ʱ5΢(STC90C52RC@12M)
ͬĹ,Ҫ˺עʱӹʱҪ޸
1TMCUʱ,ʱ
**************************************/
void Delay5us()
{
    _nop_();_nop_();_nop_();_nop_();
    _nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
	_nop_();_nop_();_nop_();_nop_();
}

/**************************************
ʱ5(STC90C52RC@12M)
ͬĹ,Ҫ˺
1TMCUʱ,ʱ
**************************************/
void Delay5ms()
{
    WORD n = 560;

    while (n--);
}

/**************************************
ʼź
**************************************/
void BH1750_Start()
{
    SDA = 1;                    //
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SDA = 0;                    //½
    Delay5us();                 //ʱ
    SCL = 0;                    //ʱ
}

/**************************************
ֹͣź
**************************************/
void BH1750_Stop()
{
    SDA = 0;                    //
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SDA = 1;                    //
    Delay5us();                 //ʱ
}

/**************************************
Ӧź
ڲ:ack (0:ACK 1:NAK)
**************************************/
void BH1750_SendACK(bit ack)
{
    SDA = ack;                  //дӦź
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    SCL = 0;                    //ʱ
    Delay5us();                 //ʱ
}

/**************************************
Ӧź
**************************************/
bit BH1750_RecvACK()
{
    SCL = 1;                    //ʱ
    Delay5us();                 //ʱ
    CY = SDA;                   //Ӧź
    SCL = 0;                    //ʱ
    Delay5us();                 //ʱ

    return CY;
}

/**************************************
IIC߷һֽ
**************************************/
void BH1750_SendByte(BYTE dat)
{
    BYTE i;

    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;              //Ƴݵλ
        SDA = CY;               //ݿ
        SCL = 1;                //ʱ
        Delay5us();             //ʱ
        SCL = 0;                //ʱ
        Delay5us();             //ʱ
    }
    BH1750_RecvACK();
}

/**************************************
IIC߽һֽ
**************************************/
BYTE BH1750_RecvByte()
{
    BYTE i;
    BYTE dat = 0;

    SDA = 1;                    //ʹڲ,׼ȡ,
    for (i=0; i<8; i++)         //8λ
    {
        dat <<= 1;
        SCL = 1;                //ʱ
        Delay5us();             //ʱ
        dat |= SDA;             //               
        SCL = 0;                //ʱ
        Delay5us();             //ʱ
    }
    return dat;
}

//*********************************

void Single_Write_BH1750(uchar REG_Address)
{
    BH1750_Start();                  //ʼź
    BH1750_SendByte(SlaveAddress);   //豸ַ+дź
    BH1750_SendByte(REG_Address);    //ڲĴַ
  //  BH1750_SendByte(REG_data);       //ڲĴݣ
    BH1750_Stop();                   //ֹͣź
}

//********ֽڶȡ*****************************************
/*
uchar Single_Read_BH1750(uchar REG_Address)
{  uchar REG_data;
    BH1750_Start();                          //ʼź
    BH1750_SendByte(SlaveAddress);           //豸ַ+дź
    BH1750_SendByte(REG_Address);                   //ʹ洢Ԫַ0ʼ	
    BH1750_Start();                          //ʼź
    BH1750_SendByte(SlaveAddress+1);         //豸ַ+ź
    REG_data=BH1750_RecvByte();              //Ĵ
	BH1750_SendACK(1);   
	BH1750_Stop();                           //ֹͣź
    return REG_data; 
}
*/
//*********************************************************
//
//BH1750ڲ
//
//*********************************************************
void Multiple_read_BH1750(void)
{   uchar i;	
    BH1750_Start();                          //ʼź
    BH1750_SendByte(SlaveAddress+1);         //豸ַ+ź
	
	 for (i=0; i<3; i++)                      //ȡ2ַݣ洢BUF
    {
        BUF[i] = BH1750_RecvByte();          //BUF[0]洢0x32ַе
        if (i == 3)
        {

           BH1750_SendACK(1);                //һҪNOACK
        }
        else
        {		
          BH1750_SendACK(0);                //ӦACK
       }
   }

    BH1750_Stop();                          //ֹͣź
    Delay5ms();
}


//ʼBH1750Ҫοpdf޸****
void Init_BH1750()
{
   Single_Write_BH1750(0x01);  

}
//*********************************************************
//********
//*********************************************************
void main()
{  
   float temp;
   delay_nms(100);	    //ʱ100ms	
   InitLcd();           //ʼLCD
   Init_BH1750();       //ʼBH1750
 
  while(1)              //ѭ
  { 

    Single_Write_BH1750(0x01);   // power on
    Single_Write_BH1750(0x10);   // H- resolution mode

     delay_nms(180);              //ʱ180ms

    Multiple_Read_BH1750();       //ݣ洢BUF

    dis_data=BUF[0];
    dis_data=(dis_data<<8)+BUF[1];//ϳݣ
    
    temp=(float)dis_data/1.2;

    conversion(temp);         //ݺʾ
	DisplayOneChar(0,0,'L'); 
	DisplayOneChar(1,0,'i'); 
	DisplayOneChar(2,0,'g'); 
	DisplayOneChar(3,0,'h'); 
	DisplayOneChar(4,0,'t'); 
    DisplayOneChar(5,0,':'); 

    DisplayOneChar(7,0,wan); //ʾ
    DisplayOneChar(8,0,qian);  
    DisplayOneChar(9,0,bai); 
    DisplayOneChar(10,0,shi); 
	DisplayOneChar(11,0,ge); 

	DisplayOneChar(13,0,'l'); ////ʾλ
	DisplayOneChar(14,0,'x');  
            
  }
} 

